/*
    Copyright (c) 2010, 2011 aizo ag, Zurich, Switzerland

    Author: Sergey 'Jin' Bostandzhyan <jin@dev.digitalstrom.org>

    This file is part of dS Assistant.

    dS-Assistant is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dS-Assistant is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

    NOTE: all APIs, especially the JSON API, offered by this application
          are subject to change without further notice.
*/


#ifndef __CREATE_DATABASE_H__
#define __CREATE_DATABASE_H__

#define CREATE_DB_V1 "\
BEGIN TRANSACTION;\
CREATE TABLE \"tasks\" (\
\"task_id\" INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL DEFAULT (1),\
\"status\" INTEGER,\
\"queued\" DATE,\
\"started\" DATE,\
\"finished\" DATE,\
\"type\" INTEGER,\
\"parameters\" TEXT DEFAULT NULL\
);\
CREATE TABLE \"taskdata_test_transmission_quality\" (\
\"dsid\" CHAR(24),\
\"upstream\" INTEGER,\
\"downstream\" INTEGER,\
\"timestamp\" DATE,\
\"errorcode\" INTEGER,\
\"task_id\" INTEGER,\
FOREIGN KEY(\"task_id\") REFERENCES tasks(task_id)\
);\
CREATE TABLE \"dsa_config\" (\
\"key\" varchar(40) primary key NOT NULL,\
\"value\" varchar(255) NOT NULL\
);\
CREATE INDEX dsa_config_key ON dsa_config(key);\
INSERT INTO \"dsa_config\" VALUES('db_version', '1');\
CREATE TRIGGER \"transmission_quality_taskdata_cleanup\" \
BEFORE DELETE ON \"tasks\" \
FOR EACH ROW BEGIN \
DELETE FROM \"taskdata_test_transmission_quality\" WHERE \"task_id\" = OLD.task_id;\
END;\
COMMIT;"

#endif//__CREATE_DATABASE_H__
